<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeMarcacaoponto extends \Doctrine\ORM\EntityRepository {
    
    /**
     * Busca as marcacoes de um determinado dia se baseando apenas na data
     */
    public function getMarcacoesDiaExato($nrorg, $nrvinculom, $dataHora)
    {
        $dataInicial = clone $dataHora;
        $dataInicial->setTime(0, 0, 0);

        $dataFinal = clone $dataInicial;
        $dataFinal->modify('+1 day');
    	
        $gpeMarcacaoponto =  'Teknisa\Model\Gestaopessoas\Entities\GpeMarcacaoponto';

$sql = <<<SQL
SELECT mp
FROM $gpeMarcacaoponto mp
WHERE mp.nrorg = :p_nrorg
    AND mp.nrvinculom = :p_nrvinculom
    AND mp.dthrajustada BETWEEN :p_datainicial AND :p_datafinal
    AND mp.nrcoletor NOT IN (21, 22, 23, 25)
ORDER BY mp.dthrajustada
SQL;

        $params = [
            'p_nrorg' => $nrorg,
            'p_nrvinculom' => $nrvinculom,
            'p_datainicial' => $dataInicial,
            'p_datafinal' => $dataFinal,
        ];

        $marcacoes = $this->getEntityManager()->createQuery($sql)->execute($params);    
        return $marcacoes ?? [];
    }

    /**
     * Verifica se existem outras marcacoes no mesmo minuto de uma informada
     */
    public function existeMarcacaoNoMesmoMinuto($nrorg, $nrvinculom, $dataHora) {
        $marcaoesDiaExato = $this->getMarcacoesDiaExato($nrorg, $nrvinculom, $dataHora);
        $marcacoesMesmaHoraMinuto = array_filter(
            $marcaoesDiaExato,
            function ($item) use ($dataHora) {
                return $item->getDthrajustada()->format('Hi') == $dataHora->format('Hi');
            }
        );
        return count($marcacoesMesmaHoraMinuto) > 0;
    }

    /**
     * Verifica se existem outras marcacoes no mesmo minuto de uma informada
     */
    public function verificaMarcacaoDuplicante($nrorg, $nrvinculom, $dataHora, $nrMarcacaoPonto) {
        $marcaoesDiaExato = $this->getMarcacoesDiaExato($nrorg, $nrvinculom, $dataHora);
        $marcacoesMesmaHoraMinuto = array_filter(
            $marcaoesDiaExato,
            function ($item) use ($dataHora, $nrMarcacaoPonto) {
                return ($item->getDthrajustada()->format('Hi') == $dataHora->format('Hi') && $item->getNrmarcacaoponto() != $nrMarcacaoPonto);
            }
        );
        return count($marcacoesMesmaHoraMinuto) > 0;
    }

    
}